// Type: Infragistics.Controls.Interactions.XamDialogWindow
// Assembly: InfragisticsWPF4.Controls.Interactions.XamDialogWindow.v11.2, Version=11.2.20112.1012, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb
// Assembly location: C:\Program Files (x86)\Infragistics\NetAdvantage 2011.2\WPF\CLR4.0\Bin\SharedXAML\InfragisticsWPF4.Controls.Interactions.XamDialogWindow.v11.2.dll

using Infragistics;
using Infragistics.Controls;
using Infragistics.Controls.Interactions.Primitives;
using Infragistics.Windows.Licensing;

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows;
using System.Windows.Automation.Peers;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Effects;

namespace Infragistics.Controls.Interactions
{
  [TemplatePart(Name = "Root", Type = typeof(DialogRootPanel))]
  [TemplateVisualState(Name = "MinimizeButtonIsVisible", GroupName = "MinimizeButtonStates")]
  [TemplateVisualState(Name = "MinimizeButtonIsNotVisible", GroupName = "MinimizeButtonStates")]
  [LicenseProvider(typeof(UltraLicenseProvider))]
  [TemplatePart(Name = "HeaderArea", Type = typeof(FrameworkElement))]
  [TemplatePart(Name = "Resize", Type = typeof(Border))]
  [TemplatePart(Name = "ContainerContext", Type = typeof(Grid))]
  [TemplatePart(Name = "NWCursor", Type = typeof(DataTemplate))]
  [TemplateVisualState(Name = "NonModal", GroupName = "ModalStates")]
  [TemplateVisualState(Name = "Modal", GroupName = "ModalStates")]
  [TemplateVisualState(Name = "MaximizeButtonIsNotVisible", GroupName = "MaximizeButtonStates")]
  [TemplatePart(Name = "SECursor", Type = typeof(DataTemplate))]
  [TemplatePart(Name = "NECursor", Type = typeof(DataTemplate))]
  [TemplatePart(Name = "SWCursor", Type = typeof(DataTemplate))]
  [TemplateVisualState(Name = "Inactive", GroupName = "ActiveStates")]
  [TemplateVisualState(Name = "Active", GroupName = "ActiveStates")]
  [TemplateVisualState(Name = "HeaderIconIsVisible", GroupName = "HeaderIconStates")]
  [TemplateVisualState(Name = "HeaderIconIsNotVisible", GroupName = "HeaderIconStates")]
  [TemplateVisualState(Name = "Maximized", GroupName = "WindowStateStates")]
  [TemplateVisualState(Name = "Normal", GroupName = "WindowStateStates")]
  [TemplateVisualState(Name = "Minimized", GroupName = "WindowStateStates")]
  [TemplateVisualState(Name = "Disabled", GroupName = "WindowStateStates")]
  [TemplateVisualState(Name = "Hidden", GroupName = "HiddenStates")]
  [TemplateVisualState(Name = "Visible", GroupName = "HiddenStates")]
  [TemplateVisualState(Name = "CloseButtonIsVisible", GroupName = "CloseButtonStates")]
  [TemplateVisualState(Name = "CloseButtonIsNotVisible", GroupName = "CloseButtonStates")]
  [TemplateVisualState(Name = "MaximizeButtonIsVisible", GroupName = "MaximizeButtonStates")]
  public class XamDialogWindow : ContentControl,
                                 ICommandTarget,
                                 INotifyPropertyChanged,
                                 IProvidePropertyPersistenceSettings
  {
    #region Constants and Fields

    public static readonly DependencyProperty CloseButtonVisibilityProperty;

    public static readonly DependencyProperty HeaderBackgroundProperty;

    public static readonly DependencyProperty HeaderForegroundProperty;

    public static readonly DependencyProperty HeaderHorizontalContentAlignmentProperty;

    public static readonly DependencyProperty HeaderIconTemplateProperty;

    public static readonly DependencyProperty HeaderIconVisibilityProperty;

    public static readonly DependencyProperty HeaderProperty;

    public static readonly DependencyProperty HeaderTemplateProperty;

    public static readonly DependencyProperty HeaderVerticalContentAlignmentProperty;

    public static readonly DependencyProperty IsActiveProperty;

    public static readonly DependencyProperty IsModalProperty;

    public static readonly DependencyProperty IsMoveableProperty;

    public static readonly DependencyProperty IsResizableProperty;

    public static readonly DependencyProperty LeftProperty;

    public static readonly DependencyProperty MaximizeButtonVisibilityProperty;

    public static readonly DependencyProperty MinimizeButtonVisibilityProperty;

    public static readonly DependencyProperty MinimizedHeaderTemplateProperty;

    public static readonly DependencyProperty MinimizedHeightProperty;

    public static readonly DependencyProperty MinimizedPanelProperty;

    public static readonly DependencyProperty MinimizedWidthProperty;

    public static readonly DependencyProperty ModalBackgroundEffectProperty;

    public static readonly DependencyProperty ModalBackgroundOpacityProperty;

    public static readonly DependencyProperty ModalBackgroundProperty;

    public static readonly DependencyProperty StartupPositionProperty;

    public static readonly DependencyProperty TopProperty;

    public static readonly DependencyProperty WindowStateProperty;

    #endregion

    #region Constructors and Destructors

    public XamDialogWindow();

    #endregion

    #region Public Events

    public event MouseEventHandler HeaderDoubleClick;

    public event EventHandler<EventArgs> IsActiveChanged;

    public event EventHandler<MovedEventArgs> Moved;

    public event EventHandler<MovingEventArgs> Moving;

    public event PropertyChangedEventHandler PropertyChanged;

    public event EventHandler<WindowStateChangedEventArgs> WindowStateChanged;

    public event EventHandler<WindowStateChangingEventArgs> WindowStateChanging;

    #endregion

    #region Public Properties

    public Visibility CloseButtonVisibility { get; set; }

    public CustomCursors CustomCursors { get; set; }

    public object Header { get; set; }

    public Brush HeaderBackground { get; set; }

    public Brush HeaderForeground { get; set; }

    public HorizontalAlignment HeaderHorizontalContentAlignment { get; set; }

    public DataTemplate HeaderIconTemplate { get; set; }

    public Visibility HeaderIconVisibility { get; set; }

    public DataTemplate HeaderTemplate { get; set; }

    public VerticalAlignment HeaderVerticalContentAlignment { get; set; }

    public bool IsActive { get; set; }

    public bool IsModal { get; set; }

    public bool IsMoveable { get; set; }

    public bool IsResizable { get; set; }

    public KeyboardSettings KeyboardSettings { get; set; }

    public double Left { get; set; }

    public Visibility MaximizeButtonVisibility { get; set; }

    public Visibility MinimizeButtonVisibility { get; set; }

    public DataTemplate MinimizedHeaderTemplate { get; set; }

    public double MinimizedHeight { get; set; }

    public Panel MinimizedPanel { get; set; }

    public double MinimizedWidth { get; set; }

    public Brush ModalBackground { get; set; }

    public Effect ModalBackgroundEffect { get; set; }

    public double ModalBackgroundOpacity { get; set; }

    public StartupPosition StartupPosition { get; set; }

    public double Top { get; set; }

    public Infragistics.Controls.Interactions.WindowState WindowState { get; set; }

    #endregion

    #region Explicit Interface Properties

    List<string> IProvidePropertyPersistenceSettings.PriorityProperties { get; }

    List<string> IProvidePropertyPersistenceSettings.PropertiesToIgnore { get; }

    #endregion

    #region Properties

    protected internal DialogRootPanel RootElement { get; }

    protected virtual List<string> PriorityProperties { get; }

    protected virtual List<string> PropertiesToIgnore { get; }

    #endregion

    #region Public Methods and Operators

    public void BringToFront();

    public void CenterDialogWindow();

    public void Close();

    public void Maximize();

    public void Minimize();

    public override void OnApplyTemplate();

    public void Show();

    #endregion

    #region Explicit Interface Methods

    object ICommandTarget.GetParameter(CommandSource source);

    bool ICommandTarget.SupportsCommand(ICommand command);

    void IProvidePropertyPersistenceSettings.FinishedLoadingPersistence();

    #endregion

    #region Methods

    protected override Size ArrangeOverride(Size arrangeBounds);

    protected virtual void EnsureVisualStates();

    protected virtual void FinishedLoadingPersistence();

    protected virtual object GetParameter(CommandSource source);

    protected void HideCustomCursor();

    protected virtual void MoveDialogByOffset(double offsetX, double offsetY);

    protected override AutomationPeer OnCreateAutomationPeer();

    protected virtual void OnHeaderDoubleClick(MouseButtonEventArgs e);

    protected virtual void OnIsActiveChanged(bool oldValue, bool newValue);

    protected override void OnKeyDown(KeyEventArgs e);

    protected virtual void OnMoved();

    protected virtual bool OnMoving();

    protected virtual void OnPropertyChanged(string propertyName);

    protected virtual void OnWindowStateChanged(
      Infragistics.Controls.Interactions.WindowState newWindowState,
      Infragistics.Controls.Interactions.WindowState previousWindowState);

    protected virtual bool OnWindowStateChanging(
      Infragistics.Controls.Interactions.WindowState currentWindowState,
      Infragistics.Controls.Interactions.WindowState newWindowState);

    protected bool ShowCustomCursor(DataTemplate cursorTemplate);

    protected virtual bool SupportsCommand(ICommand command);

    #endregion
  }
}
